proc PrefTkfPW {parent} {
	global Obj_Mes Glob_Pref
	global SelOpt env

	global Done_PrefTkfPW

        # Create a toplevel window
	if ![winfo exists $parent] { set parent "" }
	set w $parent.preftkfpw
	catch {destroy $w}
	if [winfo exists $w] {
		wm deiconify $w
		return
	}

	toplevel $w
	wm title $w "TkfPW Preferences"
    	wm transient $w [winfo toplevel [winfo parent $w]]

	#wm maxsize $w 270 400
	#wm minsize $w 270 300

	# Set Up a grab and focus
    	set oldFocus [focus]
    	grab $w
	focus $w
	
	#################### Main Frame Container
	set wf $w.f
	frame $wf

	#################### Create a Frame General Infos
	set wi $wf.info
	frame $wi -bd 5 -relief ridge

	label $wi.title -text "TkfPW Preferences"
	pack $wi.title -side top -fill x

	#################### Create a Frame for Dynamic info.
	set wstatus $wf.infd
	frame $wstatus -bd 5 -relief ridge
	label $wstatus.status -textvariable Obj_Mes($wstatus) \
		-width 35 -relief ridge
	pack $wstatus.status -side top -padx 3 -pady 3

	#################### Create a Frame For Entries
	set we $wf.entries
	frame $we -bd 5 -relief sunken
	set widthe 25

	# fPW Directory
	frame $we.fpwdir -bd 2 -relief ridge
	label $we.fpwdir.inf -text "fPW Directory (\$HOME\/)" -width $widthe -anchor w
	entry $we.fpwdir.prompt -width 20 -textvariable Glob_Pref(fPWDirectory)
	pack $we.fpwdir.inf $we.fpwdir.prompt -side left
	bind $we.fpwdir.prompt <Return>	{
		if [catch {cd $env(HOME)/$Glob_Pref(fPWDirectory)}] {
			tk_dialog .pref {TkfPW Configure Error} \
			"Unknown fPW Path :\n' $env(HOME)/$Glob_Pref(fPWDirectory) '" error 0 {Damned !}
		}
					}
#	bind $we.fpwdir.prompt   <Enter> [list show-status "Enter fPW Path" $wstatus]
	bind $we.fpwdir.prompt   <Enter> [list show-status "fPW Path is Fixed !!!" $wstatus]

	# Shared Lib Directory
	frame $we.sharedlibdir -bd 2 -relief ridge
	label $we.sharedlibdir.inf -text "Shared Lib Directory" -width $widthe -anchor w
	entry $we.sharedlibdir.prompt -width 20 -textvariable Glob_Pref(SharedLib)
	pack $we.sharedlibdir.inf $we.sharedlibdir.prompt -side left
	bind $we.sharedlibdir.prompt <Return>	{
		if [catch {cd $Glob_Pref(SharedLib)}] {
			tk_dialog .pref {TkfPW Configure Error} \
			"Unknown Shared Lib Path :\n' $Glob_Pref(SharedLib) '" error 0 {Damned !}
		}
					}
	bind $we.sharedlibdir.prompt   <Enter> [list show-status "Enter Shared Lib Path" $wstatus]

	# Editor
	frame $we.fpwedit -bd 2 -relief ridge
	label $we.fpwedit.inf -text "fPW Editor" -width $widthe -anchor w
	entry $we.fpwedit.prompt -width 20 -textvariable Glob_Pref(fPWEditor)
	pack $we.fpwedit.inf $we.fpwedit.prompt -side left
	bind $we.fpwedit.prompt <Return>	{
		if ![CheckCommand $Glob_Pref(fPWEditor)] {
			tk_dialog .pref {TkfPW Configure Error} \
			"Unknown Editor :\n' $Glob_Pref(fPWEditor) '" error 0 {Damned !}
		}
					}
	bind $we.fpwedit.prompt   <Enter> [list show-status "Enter fPW Editor" $wstatus]

	# X Window Terminal Emulator
	frame $we.fpwxterm -bd 2 -relief ridge
	label $we.fpwxterm.inf -text "X Window Terminal Name" -width $widthe -anchor w
	entry $we.fpwxterm.prompt -width 20 -textvariable Glob_Pref(Xterm)
	pack $we.fpwxterm.inf $we.fpwxterm.prompt -side left
	bind $we.fpwxterm.prompt <Return>	{
		if ![CheckCommand $Glob_Pref(Xterm)] {
			tk_dialog .pref {TkfPW Configure Error} \
			"Unknown X Terminal Emulator :\n' $Glob_Pref(Xterm) '" error 0 {Damned !}
		}
					}
	bind $we.fpwxterm.prompt   <Enter> [list show-status "Enter fPW X Window Terminal Emulator" $wstatus]

	# X Window Terminal Emulator Options
	frame $we.fpwxtermopt -bd 2 -relief ridge
	label $we.fpwxtermopt.inf -text "X Window Terminal Options" -width $widthe -anchor w
	entry $we.fpwxtermopt.prompt -width 20 -textvariable Glob_Pref(XtermOpt)
	pack $we.fpwxtermopt.inf $we.fpwxtermopt.prompt -side left
	bind $we.fpwxtermopt.prompt   <Enter> [list show-status "Enter fPW X Window Terminal Options" $wstatus]

	# Time Scanning
	frame $we.fpwscan -bd 2 -relief ridge
	label $we.fpwscan.inf -text "Time Scanning (minutes!)" -width $widthe -anchor w
	entry $we.fpwscan.prompt -width 20 -textvariable Glob_Pref(fPWTimeScan)
	pack $we.fpwscan.inf $we.fpwscan.prompt -side left
	bind $we.fpwscan.prompt <Return>	{
		if ![CheckForPositiveNumber $Glob_Pref(fPWTimeScan)] {
			tk_dialog .pref {TkfPW Configure Error} \
			"Not a Positive Number :\n' $Glob_Pref(fPWTimeScan) '" error 0 {Damned !}
		}
					}
	bind $we.fpwscan.prompt   <Enter> [list show-status "Enter Time Scanning in Seconds" $wstatus]

	# Compiler choice
	frame $we.compiler -bd 2 -relief ridge
	label $we.compiler.inf -text "Compiler Name" -width $widthe -anchor w
	entry $we.compiler.prompt -width 20 -textvariable Glob_Pref(CompilerName)
	pack $we.compiler.inf $we.compiler.prompt -side left
	bind $we.compiler.prompt <Return>	{
		if ![CheckCommand $Glob_Pref(CompilerName)] {
			tk_dialog .pref {TkfPW Configure Error} \
			"Unknown Compiler :\n' $Glob_Pref(CompilerName) '" error 0 {Damned !}
		}
					}
	bind $we.compiler.prompt <Enter> [list show-status "Enter the Compiler Name" $wstatus]

	# Library Maintainer choice
	frame $we.libmaint -bd 2 -relief ridge
	label $we.libmaint.inf -text "Library Maintainer Name" -width $widthe -anchor w
	entry $we.libmaint.prompt -width 20  -textvariable Glob_Pref(Ar)
	pack $we.libmaint.inf $we.libmaint.prompt -side left
	bind $we.libmaint.prompt <Return>	{
		if ![CheckCommand $Glob_Pref(Ar)] {
			tk_dialog .pref {TkfPW Configure Error} \
			"Unknown Library Maintainer :\n' $Glob_Pref(Ar) '" error 0 {Damned !}
		}
					}
	bind $we.libmaint.prompt <Enter> [list show-status "Enter the Library Maintainer" $wstatus]

	# Library Maintainer options
	frame $we.libmaintopt -bd 2 -relief ridge
	label $we.libmaintopt.inf -text "Library Maintainer Options" -width $widthe -anchor w
	entry $we.libmaintopt.prompt -width 20 -textvariable Glob_Pref(ArOpt)
	pack $we.libmaintopt.inf $we.libmaintopt.prompt -side left
	bind $we.libmaintopt.prompt <Enter> [list show-status "Enter the Library Maintainer Options" $wstatus]

	# Loader Default Options
	frame $we.loaderopt -bd 2 -relief ridge
	label $we.loaderopt.inf -text "Loader Default Options" -width $widthe -anchor w
	entry $we.loaderopt.prompt -width 20 -textvariable Glob_Pref(LoaderOpt)
	pack $we.loaderopt.inf $we.loaderopt.prompt -side left
	bind $we.loaderopt.prompt <Enter> [list show-status "Enter the Default Loader Options" $wstatus]

	# Fortran File Extension
	frame $we.fortranext -bd 2 -relief ridge
	label $we.fortranext.inf -text "Fortran File Extension" -width $widthe -anchor w
	entry $we.fortranext.prompt -width 20 -textvariable Glob_Pref(FortranExt)
	pack $we.fortranext.inf $we.fortranext.prompt -side left
	bind $we.fortranext.prompt <Enter> [list show-status "Enter the Fortran File Extension (ex: f)" $wstatus]

	# Pack and bind the Entry Frames
	pack 	$we.fpwdir \
		$we.sharedlibdir \
		$we.fpwedit \
		$we.fpwxterm \
		$we.fpwxtermopt \
		$we.compiler \
		$we.libmaint \
		$we.libmaintopt \
		$we.loaderopt \
		$we.fortranext \
		$we.fpwscan \
		-side top -fill x

	# Automatic Scanning is disabled !
	pack forget $we.fpwscan

	bind $we <Leave> [list show-status "Ready ..." $wstatus]

	#################### Create a Frame for Options selection
	set wo $wf.options
	frame $wo -bd 5 -relief ridge

	# Create a Label for Static info.
	set wo_infs $wo.infs
	frame $wo_infs -bd 5 -relief ridge
	label $wo_infs.title -text "Compiler Options Selection" 
	pack $wo_infs.title -side top -fill x

	# create frame for selection in canvas
	set wo_sel $wo.sel
	frame $wo_sel -bd 2 -relief ridge
		# Create a Scrollable Canvas for the Selection of Options!
		set wcanvas [ScrolledCanvas $wo_sel.cvs \
				-width 20 -height 10 ]
		# Create one frame to hold everything for the selection widgets
		# and position it on the canvas
		set wselopt [frame $wcanvas.wselopt]
		$wcanvas create window 0 0 -anchor nw -window $wselopt

	# Create the buttons for the options
	set wo_but $wo.button
	frame $wo_but  -bd 5 -relief ridge
	button $wo_but.add -text Add -cursor {plus} \
		-command [list SelOpt_AddOpt $wcanvas $wselopt $wstatus]
	button $wo_but.undokill -text "Undo Kill" \
		-command [list SelOpt_UndoKillOpt $wcanvas $wselopt $wstatus] -cursor {exchange}
	button $wo_but.reset -text "Reset" \
		-command [list PrefTkfPW_ReadCompilerOptions $wcanvas $wselopt $wstatus]
	pack $wo_but.add $wo_but.undokill $wo_but.reset -side left

	# Pack
	pack $wo_infs -side top -fill x
	pack $wo_but -side bottom -pady 2m
	pack $wo_sel -expand true -fill y -side top -pady 2m

	#################### Create a Frame General Buttons
	set wb $wf.buttons
	frame $wb -relief sunken -bd 1
	button $wb.save -text Save -command [list PrefTkfPW_save $wselopt $wstatus]
	button $wb.done -text Done -command {set Done_PrefTkfPW 1}
#	button $wb.dismiss -text Dismiss -command [list QuitWinAndRestoreGrabFocus $w $oldFocus]
	button $wb.dismiss -text Dismiss -command {set Done_PrefTkfPW 0}
	pack $wb.save $wb.done $wb.dismiss -side left

	pack $wf -expand true -fill both

	bind $wb   	<Leave> [list show-status "Ready ..." $wstatus]
	bind $wb.save   <Enter> [list show-status "Save Preferences in File" $wstatus]
	bind $wb.done   <Enter> [list show-status "Save And Quit" $wstatus]
	bind $wb.dismiss <Enter> [list show-status "Quit without Saving" $wstatus]

	#################### Pack the Main Frames
	pack $wi -side top -fill both -padx 2m -pady 2m
	pack $we -side top -fill both -padx 2m -pady 2m
	pack $wb -side bottom  -padx 2m -pady 2m
	pack $wo -side top -expand true -fill both -padx 2m -pady 2m
	pack $wstatus -side bottom -fill both -padx 2m -pady 2m

	#################### Bindings the Options Buttons
	bind $wo  <Enter> [list ShowStatus "Ready ..." $wstatus]
	bind $wo  <Leave> [list ShowStatus {} $wstatus]
	bind $wo_but.add      <Enter> [list ShowStatus "Create a New Option" $wstatus]
	bind $wo_but.add      <Leave> [list ShowStatus "Ready ..." $wstatus]
	bind $wo_but.undokill <Enter> [list ShowStatus "Undo Last Killed" $wstatus]
	bind $wo_but.undokill <Leave> [list ShowStatus "Ready ..." $wstatus]
	bind $wo_but.reset    <Enter> [list ShowStatus "Reset from Last Save" $wstatus]
	bind $wo_but.reset    <Leave> [list ShowStatus "Ready ..." $wstatus]

	#################### Update the Compilation Options
	PrefTkfPW_ReadCompilerOptions $wcanvas $wselopt $wstatus

	# Disable Changes for fPW Home Directory (next version ? ...)
	$we.fpwdir.prompt configure -state disabled

	# Waiting for The User Agreement ...
	tkwait variable Done_PrefTkfPW

	# Save Options .?.
	if { $Done_PrefTkfPW == 1 } { PrefTkfPW_save $wselopt $wstatus }

	# Proper End
	QuitWinAndRestoreGrabFocus $w $oldFocus
}
proc PrefTkfPW_ReadCompilerOptions {wcanvas wselopt wstatus} {
	global Glob_Pref

	# Clean the Option Window
	SelOpt_CleanWinOpt $wselopt

	# Read the" Option@Flag" from default ...
	set Glob_Pref(CompilerOptions) [SetListValFlag01 [PrefTkfPW_read $Glob_Pref(File) {Compiler Options} $wstatus]]

	# Store the Option@Flag list into global array SelOpt
	SelOpt_ListToArray $Glob_Pref(CompilerOptions) $wselopt 

	# Update the Option Window and put a grab on it
	SelOpt_UpdateOpt $wcanvas $wselopt $wstatus
}
proc PrefTkfPW_read {file keyword wstatus} {
# Read in a TkfPW Preferences File
	set list {}
	# Open a stream for file
	if [catch {open $file r} fileId] {
		PRINT "proc PrefTkfPW_read : $fileId"
		ShowStatus "Cannot open file\n$file" $wstatus
	} else {
		# Extract the items attached to keyword
		set i 0 ; set list {}
		ShowStatus "keyword $keyword" $wstatus
		while { [gets $fileId line] >=0 } {
			# test the line
			if [ regexp (^$keyword) $line ] {
				set line_split [lrange [split $line @] 1 end]
				set list_item {} ; set num_item 0
				foreach item $line_split {
					set item_clean [string trim $item]
					if { $num_item == 0 } {
						set list_item $item_clean
					} else {
						lappend list_item @$item_clean
					}
					incr num_item
				}
				# if ok, update the list
				if {$list_item != {}} { lappend list $list_item }
			}
		}
		close $fileId
		ShowStatus "Options from file [file tail $file]" $wstatus
	}
	return $list
}

proc PrefTkfPW_save  {w wstatus} {
	global Glob_Pref
	global SelOpt

	# Open a stream for file to save
	if [catch {open $Glob_Pref(File) w} fileId] {
		PRINT "proc PrefTkfPW_save : $fileId"
		tk_dialog .pref {TkfPW Save Preferences} \
		"Cannot write in file\n$Glob_Pref(File)" error 0 {See what's Wrong !}
	} else {
		# Update the Compiler Options List
		set Glob_Pref(CompilerOptions) {}
		for {set  i 1} {$i <= $SelOpt($w,num)} {incr i} {
			lappend Glob_Pref(CompilerOptions) "$SelOpt($w,$i,val)@$SelOpt($w,$i)"
		}
		# Write the options to file
		set last_update [exec date "+%d/%m/%y %H:%M:%S"]
		puts $fileId "# TkfPW Default Settings. Do not edit please."
		puts $fileId "Last Update @ $last_update @ $Glob_Pref(TKFPW_HOST) @ [exec uname -sr]"
		puts $fileId "TkfPW Version @ $Glob_Pref(TKFPW_version)"
		puts $fileId "TkfPW PatchLevel @ $Glob_Pref(TKFPW_patchlevel)"
		puts $fileId "fPW Directory @ $Glob_Pref(fPWDirectory)"
		puts $fileId "Shared Lib Directory @ $Glob_Pref(SharedLib)"
		puts $fileId "X Editor @ $Glob_Pref(fPWEditor)"
		puts $fileId "X Terminal Name @ $Glob_Pref(Xterm)"
		puts $fileId "X Terminal Options @ $Glob_Pref(XtermOpt)"
		puts $fileId "Time Scanning (min.)@ $Glob_Pref(fPWTimeScan)"
		puts $fileId "Compiler Name @ $Glob_Pref(CompilerName)"
		puts $fileId "Loader Options @ $Glob_Pref(LoaderOpt)"
		puts $fileId "Fortran File Extension @ $Glob_Pref(FortranExt)"
		foreach item $Glob_Pref(CompilerOptions) {
			puts $fileId "Compiler Options @ $item"
		}
		puts $fileId "Library Maintainer Name    @ $Glob_Pref(Ar)"
		puts $fileId "Library Maintainer Options @ $Glob_Pref(ArOpt)"
		close $fileId
		ShowStatus "Options saved in file\n$Glob_Pref(File)" $wstatus
	}
}
proc QuitWinAndRestoreGrabFocus {w oldfocus} {
# Release the grab on w and focus then destroy
	catch {grab release $w}
	catch {raise $oldfocus $w}
    	catch {focus $oldfocus}
	destroy $w
}
